// (c) 2002 by Jrn Loviscach

#if !defined(BEZIER_H)
#define BEZIER_H

class Bezier  
{
	public:
	Bezier();
	Bezier(const double* pX, const double* pY, const double* pInvD);
	Bezier(const Bezier& bez);
	virtual ~Bezier();
	double GetX(int num) const;
	double GetY(int num) const;
	double GetInvD(int num) const;
	double FitJoin(const Bezier& b1, const Bezier& b2, double t);
	double GetXt(double t) const;
	double GetYt(double t) const;
	double GetInvDt(double t) const;
	double GetDerivt(double t) const;

	private:
	double x[4], y[4], invD[4];

	#ifndef NDEBUG
	bool hasData;
	#endif
};

#endif