// (c) 2002 by Jrn Loviscach

#if !defined(BEZIERPATH_H)
#define BEZIERPATH_H

#include <vector>
#include "bezier.h"
#include "pixelpath.h"

class BezierPath  
{
public:
	BezierPath();
	virtual ~BezierPath();
	void Init(const PixelPath& pp);
	void Fit(double precision);
	double GetX(int i, int num) const;
	double GetY(int i, int num) const;
	double GetInvD(int i, int num) const;
	int GetLength() const;
	double GetXt(int i, double t) const;
	double GetYt(int i, double t) const;
	double GetInvDt(int i, double t) const;
	double GetDerivt(int i, double t) const;
private:
	std::vector<Bezier*> *bezierVector;
	bool hasPath;
};

#endif