// (c) 2002 by Jrn Loviscach

#if !defined(BEZIERPATHCOLLECTION_H)
#define BEZIERPATHCOLLECTION_H

#include <assert.h>
class BezierPath;
#include "PixelPathCollection.h"

class BezierPathCollection  
{
	public:
	BezierPathCollection();
	virtual ~BezierPathCollection();
	void Trace(const PixelPathCollection& pixPathColl, double fitPrec);
	void WriteEPSFile(const std::string filename) const;
	int GetLength() const { assert(hasPath); return pathColl.size(); }
	const BezierPath* GetPath(int i) const { assert(hasPath); return pathColl[i]; }
	int GetWidth() const { assert(hasPath); return width_; }
	int GetHeight() const { assert(hasPath); return height_; }
	void CreateTestBitmap(Bitmap& bm) const;

	private:
	std::vector<BezierPath*> pathColl;
	int width_;
	int height_;
	bool hasPath;
};

#endif