// (c) 2002 by Jrn Loviscach
// This is Maxon-stlye C++, no #include "adapt.h".

#include "brushdialog.h"
#include "brush.h"

BrushDialog::BrushDialog(LONG brushID, BaseContainer& brushData, const String& which)
: brushID_(brushID), brushData_(brushData), which_(which)
{
}

BrushDialog::~BrushDialog()
{
}

Bool BrushDialog::CreateLayout()
{
	SetTitle(which_ + ": " + GetBrush(brushID_)->GetName().c_str());

	Bool isOK = TRUE;

	isOK = isOK && GroupBegin(0, BFH_CENTER|BFV_SCALEFIT, 2, 0, 0, 0);

	INT i;
	for(i = 0; i < GetBrush(brushID_)->GetNumParams(); ++i)
	{
		isOK = isOK && AddStaticText(0, BFH_SCALEFIT|BFV_CENTER, 0, 0,
			String(GetBrush(brushID_)->GetParamName(i).c_str()), 0);
		isOK = isOK && AddEditNumberArrows(4000 + i, BFH_CENTER|BFV_CENTER);
	}

	isOK = isOK && GroupEnd();
	
	isOK = isOK && AddDlgGroup(DLG_OK|DLG_CANCEL);

	return isOK;
}

Bool BrushDialog::InitValues()
{
	Bool isOK = TRUE;

	INT i;
	for(i = 0; i < GetBrush(brushID_)->GetNumParams(); ++i)
	{
		if(GetBrush(brushID_)->IsIntParam(i))
		{
			isOK = isOK && SetLong(4000+i, &brushData_, 1000+i,
				(LONG)(GetBrush(brushID_)->MinParamVal(i)+0.5),
				(LONG)(GetBrush(brushID_)->MaxParamVal(i)+0.5));
		}
		else
		{
			isOK = isOK && SetReal(4000+i, &brushData_, 2000+i,
				GetBrush(brushID_)->MinParamVal(i),
				GetBrush(brushID_)->MaxParamVal(i));
		}
	}

	return isOK;
}

Bool BrushDialog::Command(LONG id, const BaseContainer&)
{
	Bool isOK = TRUE;

	//on OK write data from UI elements into container
	if(id == IDC_OK)
	{
		INT i;
		for(i = 0; i < GetBrush(brushID_)->GetNumParams(); ++i)
		{
			if(GetBrush(brushID_)->IsIntParam(i))
			{
				isOK = isOK && GetLong(4000+i, &brushData_, 1000+i);
			}
			else
			{
				isOK = isOK && GetReal(4000+i, &brushData_, 2000+i);
			}
		}
		Close();
	}
	else if(id == IDC_CANCEL)
	{
		Close();
	}

	return isOK;
}