// (c) 2002 by Jrn Loviscach
// a graphics buffer to store depth etc.

#if !defined(GBUFFER_H)
#define GBUFFER_H

#include "params.h"

class GBuffer  
{
public:
	GBuffer(long width, long height);
	virtual ~GBuffer();
	long GetWidth() const {return w_;}
	long GetHeight() const {return h_;}
	void Clear();
	void SetDepth(long x, long y, float d) {depth[x+w_*y] = d;}
	void SetObjNumber(long x, long y, long n) {objNumber[x+w_*y] = n;}
	void SetNormalX(long x, long y, float nx) {normalX[x+w_*y] = nx;}
	void SetNormalY(long x, long y, float ny) {normalY[x+w_*y] = ny;}
	void SetNormalZ(long x, long y, float nz) {normalZ[x+w_*y] = nz;}
	float GetDepth(long x, long y) const {return depth[x+w_*y];}
	long GetObjNumber(long x, long y) const {return objNumber[x+w_*y];}
	float GetNormalX(long x, long y) const {return normalX[x+w_*y];}
	float GetNormalY(long x, long y) const {return normalY[x+w_*y];}
	float GetNormalZ(long x, long y) const {return normalZ[x+w_*y];}
	unsigned char* RenderedRow(long y);
	long Render(const Params* myParams, float time, void (*setProgressBar)(long));

private:
	long h_, w_;
	float* depth;
	long* objNumber;
	float *normalX, *normalY, *normalZ;
	unsigned char *RGBA;
};

#endif