// (c) 2002 by Jrn Loviscach

#if !defined(PIXELPATHCOLLECTION_H)
#define PIXELPATHCOLLECTION_H

#include <vector>
#include <string>
#include <assert.h>
class PixelPath;
class Bitmap;

class PixelPathCollection  
{
	public:
	PixelPathCollection();
	virtual ~PixelPathCollection();
	void Trace(const Bitmap& in, int channel, int depthDiff, int minLength);
	int GetLength() const { assert(hasPath); return pathColl.size(); }
	const PixelPath* GetPath(int i) const { assert(hasPath); return pathColl[i]; }
	int GetWidth() const { assert(hasPath); return width_; }
	int GetHeight() const { assert(hasPath); return height_; }
	void CreateTestBitmap(Bitmap& bm) const;

	private:
	std::vector<PixelPath*> pathColl;
	int width_;
	int height_;
	bool hasPath;
};

#endif